from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Int, File, Float, Boolean, String

Create_Mega_Reads_V0_1_0 = CommandToolBuilder(tool="create_mega_reads", base_command=["create_mega_reads"], inputs=[ToolInput(tag="in_size", input_type=Int(optional=True), prefix="--size", doc=InputDocumentation(doc="*Number of k-mers in SuperReads")), ToolInput(tag="in_mer", input_type=Int(optional=True), prefix="--mer", doc=InputDocumentation(doc="*Mer size")), ToolInput(tag="in_fine_mer", input_type=Int(optional=True), prefix="--fine-mer", doc=InputDocumentation(doc="Mer size for fine alignment")), ToolInput(tag="in_psa_min", input_type=Int(optional=True), prefix="--psa-min", doc=InputDocumentation(doc="Min suffix length in SA. Increase for speed up at the cost of memory (13)")), ToolInput(tag="in_unit_igs_lengths", input_type=File(optional=True), prefix="--unitigs-lengths", doc=InputDocumentation(doc="Length of k-unitigs")), ToolInput(tag="in_unit_igs_sequences", input_type=File(optional=True), prefix="--unitigs-sequences", doc=InputDocumentation(doc="Fasta file containing the sequence of the k-unitigs")), ToolInput(tag="in_k_mer", input_type=Int(optional=True), prefix="--k-mer", doc=InputDocumentation(doc="*Length of k-mer used to create k-unitigs")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="Number of threads (1)")), ToolInput(tag="in_output", input_type=File(optional=True), prefix="--output", doc=InputDocumentation(doc="Output file (stdout)")), ToolInput(tag="in_dot", input_type=File(optional=True), prefix="--dot", doc=InputDocumentation(doc="Write an overlap graph (dot file)")), ToolInput(tag="in_stretch_constant", input_type=Int(optional=True), prefix="--stretch-constant", doc=InputDocumentation(doc="Constant tolerated stretch between sequences (10)")), ToolInput(tag="in_stretch_factor", input_type=Float(optional=True), prefix="--stretch-factor", doc=InputDocumentation(doc="Factor tolerated stretch between sequences (1.3)")), ToolInput(tag="in_stretch_cap", input_type=Float(optional=True), prefix="--stretch-cap", doc=InputDocumentation(doc="Maximum distance between two consecutive k-mers in LIS (10000.0)")), ToolInput(tag="in_window_size", input_type=Int(optional=True), prefix="--window-size", doc=InputDocumentation(doc="Check stretch on every window of k-mer this size (1)")), ToolInput(tag="in_overlap_play", input_type=Int(optional=True), prefix="--overlap-play", doc=InputDocumentation(doc="Play in overlap length between position and k-unitig lengths (1.3)")), ToolInput(tag="in_errors", input_type=Int(optional=True), prefix="--errors", doc=InputDocumentation(doc="Number of average errors slack for overlap computation (3.0)")), ToolInput(tag="in_bases_matching", input_type=Float(optional=True), prefix="--bases-matching", doc=InputDocumentation(doc="Filter base on percent of bases matching (17.0)")), ToolInput(tag="in_mers_matching", input_type=Float(optional=True), prefix="--mers-matching", doc=InputDocumentation(doc="Filter base on percent of k-mer matching (0.0)")), ToolInput(tag="in_max_match", input_type=Boolean(optional=True), prefix="--max-match", doc=InputDocumentation(doc="Use secondary matches (false)")), ToolInput(tag="in_max_count", input_type=Int(optional=True), prefix="--max-count", doc=InputDocumentation(doc="Maximum mer count in super read to be used for alignment (5000)")), ToolInput(tag="in_bases", input_type=Boolean(optional=True), prefix="--bases", doc=InputDocumentation(doc="Maximize number of bases in path, not the number of mers (false)")), ToolInput(tag="in_density", input_type=Float(optional=True), prefix="--density", doc=InputDocumentation(doc="Minimum density of k-mers in mega-read (0.029)")), ToolInput(tag="in_min_length", input_type=Int(optional=True), prefix="--min-length", doc=InputDocumentation(doc="Minimum length of a mega-read (100.0)")), ToolInput(tag="in_tiling", input_type=String(optional=True), prefix="--tiling", doc=InputDocumentation(doc="|greedy|maximal|weighted\nOption for tiling mega-reads (greedy)")), ToolInput(tag="in_trim", input_type=String(optional=True), prefix="--trim", doc=InputDocumentation(doc="|match|branch             How to trim mega-read (none)")), ToolInput(tag="in_super_reads", input_type=File(optional=True), prefix="--superreads", doc=InputDocumentation(doc="SuperReads sequence file")), ToolInput(tag="in_pac_bio", input_type=File(optional=True), prefix="--pacbio", doc=InputDocumentation(doc="PacBio read sequence file")), ToolInput(tag="in_create_mega_reads_cmdline", input_type=String(), position=0, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_output", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output", type_hint=File()), doc=OutputDocumentation(doc="Output file (stdout)"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Create_Mega_Reads_V0_1_0().translate("wdl", allow_empty_container=True)

